
#ifdef __cplusplus
extern "C" {
#endif

void delay(unsigned long msec);
void init_timer(unsigned char seconds);
double duration();
char timer_expired();

#ifdef __cplusplus
};
#endif


extern unsigned long gethex(
		unsigned long vmin,
		unsigned long vmax,
		unsigned long iv,
		char  *esc);

#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");

#define ESC_MASK          1   // gethex function masks
#define LEFT_ARR_MASK  0x10
#define RIGHT_ARR_MASK 0x20
#define UP_ARR_MASK    0x40
#define DOWN_ARR_MASK  0x80


#define KEY_ESC        0x1b     
#define KEY_CNTR_BREAK 0x3
#define KEY_ENTER      0xd
#define KEY_CNTR_ENTER 0xa
#define KEY_CR         0xd
#define KEY_LF         0xa
#define KEY_BACKSP     0x8
#define KEY_TAB        0x9
#define KEY_SHIFT_TAB  0xf00
#define KEY_CNTR_TAB   0x9400

#define KEY_F1         0x3b00
#define KEY_F2         0x3c00
#define KEY_F3         0x3d00
#define KEY_F4         0x3e00
#define KEY_F5         0x3f00
#define KEY_F6         0x4000
#define KEY_F7         0x4100
#define KEY_F8         0x4200
#define KEY_F9         0x4300
#define KEY_F10        0x4400
#define KEY_F11        0x8500
#define KEY_F12        0x8600
#define KEY_SHIFT_F1   0x5400
#define KEY_SHIFT_F2   0x5500
#define KEY_SHIFT_F3   0x5600
#define KEY_SHIFT_F4   0x5700
#define KEY_SHIFT_F5   0x5800
#define KEY_SHIFT_F6   0x5900
#define KEY_SHIFT_F7   0x5a00
#define KEY_SHIFT_F8   0x5b00
#define KEY_SHIFT_F9   0x5c00
#define KEY_SHIFT_F10  0x5d00
#define KEY_SHIFT_F11  0x8700
#define KEY_SHIFT_F12  0x8800
#define KEY_CNTR_F1    0x5e00
#define KEY_CNTR_F2    0x5f00
#define KEY_CNTR_F3    0x6000
#define KEY_CNTR_F4    0x6100
#define KEY_CNTR_F5    0x6200
#define KEY_CNTR_F6    0x6300
#define KEY_CNTR_F7    0x6400
#define KEY_CNTR_F8    0x6500
#define KEY_CNTR_F9    0x6600
#define KEY_CNTR_F10   0x6700
#define KEY_CNTR_F11   0x8900
#define KEY_CNTR_F12   0x8a00
#define KEY_ALT_F1     0x6800
#define KEY_ALT_F2     0x6900
#define KEY_ALT_F3     0x6a00
#define KEY_ALT_F4     0x6b00
#define KEY_ALT_F5     0x6c00
#define KEY_ALT_F6     0x6d00
#define KEY_ALT_F7     0x6e00
#define KEY_ALT_F8     0x6f00
#define KEY_ALT_F9     0x7000
#define KEY_ALT_F10    0x7100
#define KEY_ALT_F11    0x8b00
#define KEY_ALT_F12    0x8c00

#define KEY_INS             0x5200
#define KEY_DEL             0x5300
#define KEY_HOME            0x4700
#define KEY_END             0x4f00
#define KEY_UP              0x4800
#define KEY_DOWN            0x5000
#define KEY_LEFT            0x4b00
#define KEY_RIGHT           0x4d00
#define KEY_CENTER          0x4c00  // "5" on numeric pad 
#define KEY_PGUP            0x4900
#define KEY_PGDN            0x5100
#define KEY_CNTR_INS        0x9200
#define KEY_CNTR_DEL        0x9300
#define KEY_CNTR_HOME       0x7700
#define KEY_CNTR_END        0x7500
#define KEY_CNTR_UP         0x8d00
#define KEY_CNTR_DOWN       0x9100
#define KEY_CNTR_LEFT       0x7300
#define KEY_CNTR_RIGHT      0x7400
#define KEY_CNTR_CENTER     0x8f00  // "5" on numeric pad 
#define KEY_CNTR_PGUP       0x8400
#define KEY_CNTR_PGDN       0x7600
#define KEY_SHIFT_END       0x4f31
#define KEY_SHIFT_DOWN      0x5032
#define KEY_SHIFT_PGDN      0x5133
#define KEY_SHIFT_LEFT      0x4b34
#define KEY_SHIFT_CENTER    0x4c35
#define KEY_SHIFT_RIGHT     0x4d36
#define KEY_SHIFT_HOME      0x4737
#define KEY_SHIFT_UP        0x4838
#define KEY_SHIFT_PGUP      0x4939
#define KEY_SHIFT_INS       0x5230
#define KEY_SHIFT_DEL       0x532e

#define KEY_GR_ENTER        0xe00d  // aux GRAY KEYs 
#define KEY_GR_SLASH        0xe02f
#define KEY_GR_ARTERISK     0x372a
#define KEY_GR_MINUS        0x4a2d
#define KEY_GR_PLUS         0x4e2b

#define KEY_NK_1            0x4f31  // 10 key NUMERIC KEYPAD 
#define KEY_NK_2            0x5032
#define KEY_NK_3            0x5133
#define KEY_NK_4            0x4b34
#define KEY_NK_5            0x4c35
#define KEY_NK_6            0x4d36
#define KEY_NK_7            0x4737
#define KEY_NK_8            0x4838
#define KEY_NK_9            0x4939
#define KEY_NK_0            0x5230
#define KEY_NK_POINT        0x532e

#define KEY_AUX_INS         0x52e0 // 101-kbd specific 
#define KEY_AUX_DEL         0x53e0
#define KEY_AUX_HOME        0x47e0
#define KEY_AUX_END         0x4fe0
#define KEY_AUX_UP          0x48e0
#define KEY_AUX_DOWN        0x50e0
#define KEY_AUX_LEFT        0x4be0
#define KEY_AUX_RIGHT       0x4de0
#define KEY_AUX_PGUP        0x49e0
#define KEY_AUX_PGDN        0x51e0
#define KEY_AUX_CNTR_INS    0x92e0
#define KEY_AUX_CNTR_DEL    0x93e0
#define KEY_AUX_CNTR_HOME   0x77e0
#define KEY_AUX_CNTR_END    0x75e0
#define KEY_AUX_CNTR_UP     0x8de0
#define KEY_AUX_CNTR_DOWN   0x91e0
#define KEY_AUX_CNTR_LEFT   0x73e0
#define KEY_AUX_CNTR_RIGHT  0x74e0
#define KEY_AUX_CNTR_PGUP   0x84e0
#define KEY_AUX_CNTR_PGDN   0x76e0

#define KEY_AUX_ALT_INS     0xa200
#define KEY_AUX_ALT_DEL     0xa300
#define KEY_AUX_ALT_HOME    0x9700
#define KEY_AUX_ALT_END     0x9f00
#define KEY_AUX_ALT_UP      0x9900
#define KEY_AUX_ALT_DOWN    0xa100
#define KEY_AUX_ALT_LEFT    0x9b00
#define KEY_AUX_ALT_RIGHT   0x9d00
#define KEY_AUX_ALT_PGUP    0x9800
#define KEY_AUX_ALT_PGDN    0xa000
#define KEY_AUX_CNTR_SYSRQ  0x7200
////////////////////////////////////////////////////

