//=============================================================================
//	TORNADO Software Development Kit for Windows. rev.1.
//	(C) MicroLAB Systems Ltd, 2000-2002
//
//	WEB:	http://www.mlabsys.com
//	FTP:	ftp://ftp.mlabsys.com
//	E-mail:	techsupport@mlabsys.com
//	
//
//	file:
//	-----
//		TSDK LID list view demo.
//
//	description:
//	------------
//		This demo provides an example of LID (logical index descriptor)
//		list veiwing.
// 
//
//  Copyright:
//	----------
//		This demo is distributed free of charge and as it is without
//		any obligation from MicroLAB Systems.
//
//=============================================================================



#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

#include "th.h"



void main(int argc, char* argv[])
{ 
	int err=TH_OK;
	ULONG i;
	TH_LID_DD  LID;		
	int LID_list_open=0;
	ULONG	LID_list_records=0;

	printf("\nTSDK Demo: LID List Viewer. v.1.0\n");
	printf("Copyright (C) MicroLAB Systems Ltd, 2000-2002\n\n");

	// open and lock LID list
	if((err=TH_open_LID_list())!=TH_OK)
		goto exit;

	LID_list_open=1;

	// get number of LID list records
	if((err=TH_LID_list_records())<0)
		goto exit;
	LID_list_records=err;


	printf("number of LID list records = %d\n\n",LID_list_records);

	if(LID_list_records>0)
	{
		for(i=0;i<LID_list_records;i++)
		{
			// read LID list
			if((err=TH_read_LID(i,&LID))!=TH_OK)
				goto exit;

			// display LID data
			printf("LID #%d:\n",i);
			printf("    record_id    = %d\n",LID.record_id);
			printf("    index        = %d\n",LID.index);
			printf("    board        = %s\n",LID.board_id==TH_ISA_BOARD_TYPE ? "ISA":"PCI");

			if(LID.board_id==TH_ISA_BOARD_TYPE)
				printf("    ISA I/O addr = 0x%x\n\n",LID.io_addr);
			else
				printf("    PCI slot     = %x\n\n",LID.slot);
		}
	}


exit:
	// deallocate section header list if any
	if(LID_list_open==1) 
		TH_close_LID_list();

	// print error message if any
	if(err!=TH_OK)	
		printf("%s\n%s\n",TH_err_message(err),TH_err_flag_function_name());

	printf("\n");
}
